"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const practical_logger_core_1 = require("@offirmo/practical-logger-core");
const firefox_1 = __importDefault(require("./sinks/advanced/firefox"));
exports.sink_firefox = firefox_1.default;
const chromium_1 = __importDefault(require("./sinks/advanced/chromium"));
exports.sink_chromium = chromium_1.default;
const safari_1 = __importDefault(require("./sinks/advanced/safari"));
exports.sink_safari = safari_1.default;
const advanced_1 = require("./sinks/advanced");
const ORIGINAL_CONSOLE = console;
function createLogger(p) {
    const sink0 = p.sink || advanced_1.create();
    let groupDepth = 0;
    function sink1(payload) {
        const shouldEscapeFromGroupCollapsedToMakeTheErrorVisible = practical_logger_core_1.LOG_LEVEL_TO_INTEGER[payload.level] <= 30 && groupDepth > 0;
        if (shouldEscapeFromGroupCollapsedToMakeTheErrorVisible) {
            while (groupDepth > 0) {
                ORIGINAL_CONSOLE.groupEnd();
                groupDepth--;
            }
        }
        return sink0(payload);
    }
    return {
        ...practical_logger_core_1.createLogger(p, sink1),
        group(groupTitle) {
            ORIGINAL_CONSOLE.group(groupTitle);
            groupDepth++;
        },
        groupCollapsed(groupTitle) {
            ORIGINAL_CONSOLE.groupCollapsed(groupTitle);
            groupDepth++;
        },
        groupEnd() {
            ORIGINAL_CONSOLE.groupEnd();
            groupDepth = Math.max(0, groupDepth - 1);
        }
    };
}
exports.createLogger = createLogger;
//# sourceMappingURL=index.js.map