import { createLogger as createLoggerCore, LOG_LEVEL_TO_INTEGER } from '@offirmo/practical-logger-core';
import sink_firefox from './sinks/advanced/firefox';
import sink_chromium from './sinks/advanced/chromium';
import sink_safari from './sinks/advanced/safari';
import { create } from './sinks/advanced';
const ORIGINAL_CONSOLE = console;
function createLogger(p) {
    const sink0 = p.sink || create();
    let groupDepth = 0;
    function sink1(payload) {
        const shouldEscapeFromGroupCollapsedToMakeTheErrorVisible = LOG_LEVEL_TO_INTEGER[payload.level] <= 30 && groupDepth > 0;
        if (shouldEscapeFromGroupCollapsedToMakeTheErrorVisible) {
            while (groupDepth > 0) {
                ORIGINAL_CONSOLE.groupEnd();
                groupDepth--;
            }
        }
        return sink0(payload);
    }
    return {
        ...createLoggerCore(p, sink1),
        group(groupTitle) {
            ORIGINAL_CONSOLE.group(groupTitle);
            groupDepth++;
        },
        groupCollapsed(groupTitle) {
            ORIGINAL_CONSOLE.groupCollapsed(groupTitle);
            groupDepth++;
        },
        groupEnd() {
            ORIGINAL_CONSOLE.groupEnd();
            groupDepth = Math.max(0, groupDepth - 1);
        }
    };
}
export { createLogger, 
// specific
sink_firefox, sink_chromium, sink_safari, };
//# sourceMappingURL=index.js.map