"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var practical_logger_core_1 = require("@offirmo/practical-logger-core");
var firefox_1 = __importDefault(require("./sinks/advanced/firefox"));
exports.sink_firefox = firefox_1.default;
var chromium_1 = __importDefault(require("./sinks/advanced/chromium"));
exports.sink_chromium = chromium_1.default;
var safari_1 = __importDefault(require("./sinks/advanced/safari"));
exports.sink_safari = safari_1.default;
var advanced_1 = require("./sinks/advanced");
var ORIGINAL_CONSOLE = console;
function createLogger(p) {
    var sink0 = p.sink || advanced_1.create();
    var groupDepth = 0;
    function sink1(payload) {
        var shouldEscapeFromGroupCollapsedToMakeTheErrorVisible = practical_logger_core_1.LOG_LEVEL_TO_INTEGER[payload.level] <= 30 && groupDepth > 0;
        if (shouldEscapeFromGroupCollapsedToMakeTheErrorVisible) {
            while (groupDepth > 0) {
                ORIGINAL_CONSOLE.groupEnd();
                groupDepth--;
            }
        }
        return sink0(payload);
    }
    return __assign({}, practical_logger_core_1.createLogger(p, sink1), { group: function (groupTitle) {
            ORIGINAL_CONSOLE.group(groupTitle);
            groupDepth++;
        },
        groupCollapsed: function (groupTitle) {
            ORIGINAL_CONSOLE.groupCollapsed(groupTitle);
            groupDepth++;
        },
        groupEnd: function () {
            ORIGINAL_CONSOLE.groupEnd();
            groupDepth = Math.max(0, groupDepth - 1);
        } });
}
exports.createLogger = createLogger;
//# sourceMappingURL=index.js.map