"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
var common_2 = require("./common");
function has_details_indicator(console_method_name) {
    return console_method_name === 'error' || console_method_name === 'warn';
}
var HEADER_FONT_SIZE_STYLE = 'font-size: 8px';
exports.sink = function (payload) {
    var level = payload.level, name = payload.name, msg = payload.msg, err = payload.err, details = payload.details;
    var console_method_name = common_1.LEVEL_TO_CONSOLE_METHOD[level];
    var console_method = console[console_method_name];
    var line = [''];
    if (!has_details_indicator(console_method_name)) {
        line = common_2.add_styled_string(line, '▷', common_2.LEVEL_TO_COLOR_STYLE[level], 'font-size: 8px', common_2.FONT_FAMILY_BETTER_PROPORTIONAL, 'margin-left: .1em', 'margin-right: .2em');
    }
    line = common_2.add_styled_string(line, '[', common_2.LEVEL_TO_COLOR_STYLE[level], HEADER_FONT_SIZE_STYLE, common_2.FONT_FAMILY_BETTER_PROPORTIONAL);
    line = common_2.add_styled_string(line, common_2.to_uniform_level(level), common_2.LEVEL_TO_COLOR_STYLE[level], HEADER_FONT_SIZE_STYLE, common_2.FONT_FAMILY_BETTER_MONOSPACE);
    line = common_2.add_styled_string(line, '] ', common_2.LEVEL_TO_COLOR_STYLE[level], HEADER_FONT_SIZE_STYLE, common_2.FONT_FAMILY_BETTER_PROPORTIONAL);
    line = common_2.add_styled_string(line, '', 'font-size: unset');
    if (name) {
        line = common_2.add_styled_string(line, name + " \u203A ", common_2.LEVEL_TO_COLOR_STYLE[level], common_2.FONT_FAMILY_BETTER_PROPORTIONAL);
    }
    line = common_2.add_styled_string(line, msg, common_2.LEVEL_TO_COLOR_STYLE[level], common_2.FONT_FAMILY_BETTER_PROPORTIONAL);
    var args = line;
    if (Object.keys(details).length)
        args.push(details);
    // err should be last because it takes a lot of room and "hides" further args
    if (err)
        args.push(err);
    console_method.apply(void 0, args);
};
exports.default = exports.sink;
//# sourceMappingURL=chromium.js.map