"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var practical_logger_core_1 = require("@offirmo/practical-logger-core");
var FONT_FAMILY_BETTER_PROPORTIONAL = 'font-family: ' + [
    '-apple-system',
    'BlinkMacSystemFont',
    'noto',
    'roboto',
    'sans-serif',
].join(', ');
exports.FONT_FAMILY_BETTER_PROPORTIONAL = FONT_FAMILY_BETTER_PROPORTIONAL;
var FONT_FAMILY_BETTER_MONOSPACE = 'font-family: ' + [
    '"Fira Code"',
    'Menlo',
    'Consolas',
    'monospace',
].join(', ');
exports.FONT_FAMILY_BETTER_MONOSPACE = FONT_FAMILY_BETTER_MONOSPACE;
var LEVEL_TO_COLOR_STYLE = {
    // empty = no need, console method already covers it well
    fatal: '',
    emerg: '',
    alert: '',
    crit: '',
    error: '',
    warning: '',
    warn: '',
    notice: 'color: #659AD2',
    info: 'color: #659AD2',
    verbose: 'color: #659AD2',
    log: '',
    debug: 'color: #9AA2AA',
    trace: 'color: #9AA2AA',
    silly: 'color: #9AA2AA',
};
exports.LEVEL_TO_COLOR_STYLE = LEVEL_TO_COLOR_STYLE;
function add_styled_string(line, chunk) {
    var styles = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        styles[_i - 2] = arguments[_i];
    }
    var existing_chunks = line[0], existing_chunks_styles = line.slice(1);
    return [
        existing_chunks + '%c' + chunk
    ].concat(existing_chunks_styles, [
        styles.join(';') + ';',
    ]);
}
exports.add_styled_string = add_styled_string;
var MIN_WIDTH = 5;
function to_uniform_level(level) {
    var str = practical_logger_core_1.LOG_LEVEL_TO_HUMAN[level]; //.slice(0, MIN_WIDTH)
    //if (str.length < MIN_WIDTH)
    str = (str + '         ').slice(0, MIN_WIDTH);
    return str;
}
exports.to_uniform_level = to_uniform_level;
//# sourceMappingURL=common.js.map